﻿Imports System
Imports System.Runtime.InteropServices

Public Class Form1
  Dim hLcWnd As Integer, hLcDrw As Integer, hProps As Integer, hStatbar As Integer, hBlock As Integer
  Dim Wfrm As Integer, Hfrm As Integer
  Dim LcEvent As F_LCEVENT
  Dim PropsWidth As Integer
  Dim MemBuf As IntPtr   ' pointer to a memory buffer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' define event procedures
        LcEvent = New F_LCEVENT(AddressOf ProcLcEvent)
        Lcad.EventSetProc(LC_EVENT_LBDOWN, LcEvent, 0, 0)
        '        Lcad.EventSetProc(LC_EVENT_MOUSEMOVE, LcEvent, 0, 0)
        Lcad.EventSetProc(LC_EVENT_WNDVIEW, LcEvent, 0, 0)
        Lcad.EventSetProc(LC_EVENT_PICKENT, LcEvent, 0, 0)

        Lcad.Initialize()
        Lcad.PropPutStr(0, LC_PROP_G_REGCODE, "abcd-abcd-1234-1234")

        ' create graphics window
        hLcWnd = Lcad.CreateWindow(Handle, LC_WS_DEFAULT Or LC_WS_BORDER Or LC_WS_RULERS Or LC_WS_VIEWTABS)
        '    Lcad.PropPutBool(hLcWnd, LC_PROP_WND_COORDS, 1)  ' display cursor coordinates in left-bottom corner of CAD window
        Lcad.WndResize(hLcWnd, 10, 30, Wfrm - 20, Hfrm - 60)

        ' create Properties window
        hProps = Lcad.CreateProps(Handle, 0)   ' the size will be set in Form1_Resize()
        ' link with graphics window
        Lcad.WndSetProps(hLcWnd, hProps)
        PropsWidth = 250   ' width of the window

        ' Create StatusBar
        hStatbar = Lcad.CreateStatbar(Handle)
        ' define statusbar fields
        Lcad.StatbarCell(hStatbar, 1, 0)
        Lcad.StatbarCell(hStatbar, 2, 100)
        Lcad.StatbarCell(hStatbar, 3, 200)
        Lcad.StatbarCell(hStatbar, 4, 350)

        Form1_Resize(sender, e)

        ' create drawing
        hLcDrw = Lcad.CreateDrawing()
        Lcad.PropPutStr(hLcDrw, LC_PROP_DRW_COLORBACKM, "20,40,60")
        Lcad.DrwNew(hLcDrw, "", hLcWnd)

        Lcad.PropPutBool(hLcWnd, LC_PROP_SEL_PICKBYRECT, False)

        hBlock = Lcad.PropGetHandle(hLcWnd, LC_PROP_WND_VIEWBLOCK)

        Lcad.BlockAddCircle(hBlock, 0, 0, 2, LC_FALSE)
        Lcad.BlockAddCircle(hBlock, 0, 0, 5, LC_FALSE)
        Lcad.BlockAddCircle(hBlock, 0, 0, 10, LC_FALSE)
        Lcad.BlockAddLine(hBlock, 0, 0, 20, 10)

        Dim hRect As Integer
        hRect = Lcad.BlockAddRect(hBlock, 0, 0, 13, 24, 0, False)
        Lcad.PropPutBool(hRect, LC_PROP_ENT_SOLIDFILL, True)
        Lcad.PropPutInt(hRect, LC_PROP_ENT_LWIDTH, 0)
        Lcad.PropPutStr(hRect, LC_PROP_ENT_FCOLOR, "100,255,0")
        Lcad.PropPutInt(hRect, LC_PROP_ENT_FALPHA, 150)

        Lcad.BlockUpdate(hBlock, LC_TRUE, 0)

        Lcad.WndZoomRect(hLcWnd, 0, 0, 0, 0)
        Lcad.PropPutBool(hLcWnd, LC_PROP_WND_CURSORCROSS, False)

        ' Lcad.PropPutInt(hLcWnd, LC_PROP_WND_OSNAP, LC_OSNAP_ALL) 'attiva tutte le opzioni di object snap
        ' Lcad.PropPutBool(hLcWnd, LC_PROP_WND_OSNAP, True) 'attiva object snap


    End Sub
    Private Sub Form1_Close(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Lcad.Uninitialize(True)
    End Sub


    Private Sub ProcLcEvent(ByVal hEvent As Integer)
        Dim EventType As Integer
        EventType = Lcad.PropGetInt(hEvent, LC_PROP_EVENT_TYPE)
        Select Case EventType
            Case LC_EVENT_LBDOWN
                ProcLBDown(hEvent)
            Case LC_EVENT_MOUSEMOVE
                ProcMouseMove(hEvent)
            Case LC_EVENT_WNDVIEW
                ProcWndView(hEvent)
            Case LC_EVENT_PICKENT
                ProcPickEnt(hEvent)
        End Select
    End Sub

    Private Sub ProcLBDown(ByVal hEvent As Integer)
        Dim hBlock As Integer, hEnt As Integer, bCtrl As Integer
        Dim X As Double, Y As Double
        bCtrl = Lcad.PropGetInt(hEvent, LC_PROP_EVENT_INT4)
        If (bCtrl = 1) Then
            hBlock = Lcad.PropGetHandle(hEvent, LC_PROP_EVENT_BLOCK)
            X = Lcad.PropGetFloat(hEvent, LC_PROP_EVENT_FLOAT1)
            Y = Lcad.PropGetFloat(hEvent, LC_PROP_EVENT_FLOAT2)
            hEnt = Lcad.BlockAddPoint(hBlock, X, Y)
            Lcad.BlockUpdate(hBlock, True, hEnt)
            Lcad.WndRedraw(hLcWnd)
            Lcad.EventReturnCode(1)
        End If
    End Sub

    Private Sub ProcMouseMove(ByVal hEvent As Integer)
        Dim szBuf As String
        Dim X As Double, Y As Double
        Dim hLcWnd As Integer

        hLcWnd = Lcad.PropGetHandle(hEvent, LC_PROP_EVENT_WND)

        ' Cursor coordinates
        X = Lcad.PropGetFloat(hEvent, LC_PROP_EVENT_FLOAT1)
        Y = Lcad.PropGetFloat(hEvent, LC_PROP_EVENT_FLOAT2)
        ' Display data in status bar
        ' X
        szBuf = X.ToString("F3")
        Lcad.StatbarText(hStatbar, 1, szBuf)
        ' Y
        szBuf = Y.ToString("F3")
        Lcad.StatbarText(hStatbar, 2, szBuf)
        ' redraw the status bar
        Lcad.StatbarRedraw(hStatbar)
    End Sub

    Private Sub ProcWndView(ByVal hEvent As Integer)
        Dim szBuf As String
        Dim X As Double, Y As Double
        Dim PixSize As Double, Lef As Double, Bot As Double, Rig As Double, Top As Double, dx As Double, dy As Double
        Dim hLcWnd As Integer

        hLcWnd = Lcad.PropGetHandle(hEvent, LC_PROP_EVENT_WND)
        PixSize = Lcad.PropGetFloat(hLcWnd, LC_PROP_WND_PIXELSIZE)
        X = Lcad.PropGetFloat(hLcWnd, LC_PROP_WND_CURX)
        Y = Lcad.PropGetFloat(hLcWnd, LC_PROP_WND_CURY)
        Lef = Lcad.PropGetFloat(hLcWnd, LC_PROP_WND_XMIN)
        Bot = Lcad.PropGetFloat(hLcWnd, LC_PROP_WND_YMIN)
        Rig = Lcad.PropGetFloat(hLcWnd, LC_PROP_WND_XMAX)
        Top = Lcad.PropGetFloat(hLcWnd, LC_PROP_WND_YMAX)
        dx = Rig - Lef
        dy = Top - Bot

        ' Display data in status bar
        ' X
        szBuf = X.ToString("F3")
        Lcad.StatbarText(hStatbar, 1, szBuf)
        ' Y
        szBuf = Y.ToString("F3")
        Lcad.StatbarText(hStatbar, 2, szBuf)
        ' Pixel size
        szBuf = "Pixel size: " + PixSize.ToString("F4")
        Lcad.StatbarText(hStatbar, 3, szBuf)
        ' visible area
        szBuf = "Visible area:  L=" + Lef.ToString("F2") + "  B=" + Bot.ToString("F2") + "  R=" + Rig.ToString("F2") + "  T=" + Bot.ToString("F2") + "   W=" + dx.ToString("F2") + "  H=" + dy.ToString("F2")
        Lcad.StatbarText(hStatbar, 4, szBuf)
        ' redraw the status bar
        Lcad.StatbarRedraw(hStatbar)
    End Sub
    Private Sub ProcPickEnt(ByVal hEvent As Integer)
        Dim ent As Integer

        'id obtained from "entity selected" event
        ent = Lcad.PropGetHandle(hEvent, LC_PROP_EVENT_ENTITY)

        'get the handle as string
        Dim idEnt As String = Lcad.PropGetStr(ent, LC_PROP_ENT_ID)

        'show results
        MsgBox("Entity ID = " & idEnt)

        ' do not select picked entity
        Lcad.EventReturnCode(1)
    End Sub
    Private Sub Form1_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim Hmenu As Integer, Hsbar As Integer, x As Integer, y As Integer, w As Integer, h As Integer
        Lcad.GetClientSize(Handle, Wfrm, Hfrm)
        Hmenu = MenuStrip1.Height()
        If hLcWnd <> 0 Then
            ' Height of the status bar
            Hsbar = Lcad.PropGetInt(0, Lcad.LC_PROP_G_SBARHEIGHT)
            ' "Properties" window position
            x = 0
            y = Hmenu
            w = PropsWidth
            h = Hfrm - Hmenu - Hsbar + 1
            Lcad.PropsResize(hProps, x, y, w, h)

            ' "CAD window" position
            x = PropsWidth
            y = Hmenu
            w = Wfrm - PropsWidth + 1
            h = Hfrm - Hmenu - Hsbar + 1
            Lcad.WndResize(hLcWnd, x, y, w, h)

            ' StatusBar position
            x = 0
            y = Hfrm - Hsbar
            w = Wfrm
            h = Hsbar
            Lcad.StatbarResize(hStatbar, x, y, w, h)

            '      Lcad.WndResize(hLcWnd, 10, 30, Wfrm - 20, Hfrm - 60)
            Lcad.WndRedraw(hLcWnd)
            Refresh()
        End If
    End Sub
    Private Sub PolylineToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PolylineToolStripMenuItem.Click
        '    Dim hBlock As Integer
        '    hBlock = Lcad.PropGetHandle(hLcWnd, LC_PROP_WND_VIEWBLOCK)
        Lcad.WndExeCommand(hLcWnd, LC_CMD_POLYLINE, 0)
    End Sub

    Private Sub ToolStripMenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem2.Click
        Lcad.WndExeCommand(hLcWnd, LC_CMD_CIRCLE, 0)

        '    Dim hLayer As Integer
        '    Dim Name As String
        '    Dim nn As Integer

        '    Name = "1234567890"
        '    nn = Name.Length()
        '    hLayer = Lcad.DrwGetFirstObject(hLcDrw, LC_OBJ_LAYER)
        '    While hLayer <> 0
        '      Name = Lcad.PropGetStr(hLayer, LC_PROP_LAYER_NAME)
        '      nn = Name.Length()
        '    hLayer = Lcad.DrwGetNextObject(hLcDrw, hLayer)
        '    End While
    End Sub

    Private Sub RasterizeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RasterizeToolStripMenuItem.Click
        Dim hDrw, hBlock As Integer
        Dim bRet As Integer
        Dim ImgWidth As Integer
        Dim Xmin, Ymin, Xmax, Ymax, W, Gap As Double
        Dim Lef, Bot, Rig, Top As Double
        Dim szFileName, szRasterFile As String

        szFileName = "c:/!OK/Projects/_drawings/DWG_DXF/Lenovo.dxf"
        szRasterFile = "c:/!OK/Projects/_drawings/DWG_DXF/Lenovo.png"

        hDrw = Lcad.CreateDrawing()
        bRet = Lcad.DrwLoad(hDrw, szFileName, 0)
        If bRet = 1 Then
            ' Set back color of Model space to White
            Lcad.PropPutInt(hDrw, LC_PROP_DRW_COLORBACKM, RGB(255, 255, 255))
            ' Set fore color of Model space to Black
            Lcad.PropPutInt(hDrw, LC_PROP_DRW_COLORFOREM, RGB(0, 0, 0))
            ' get Model block
            hBlock = Lcad.PropGetHandle(hDrw, LC_PROP_DRW_BLOCK_MODEL)
            ' get extents
            Xmin = Lcad.PropGetFloat(hBlock, LC_PROP_BLOCK_XMIN)
            Ymin = Lcad.PropGetFloat(hBlock, LC_PROP_BLOCK_YMIN)
            Xmax = Lcad.PropGetFloat(hBlock, LC_PROP_BLOCK_XMAX)
            Ymax = Lcad.PropGetFloat(hBlock, LC_PROP_BLOCK_YMAX)
            W = Xmax - Xmin
            If W > 0.0 Then
                ' increase output rect
                Gap = W / 30.0  ' blank space
                Lef = Xmin - Gap
                Bot = Ymin - Gap
                Rig = Xmax + Gap
                Top = Ymax + Gap
                ' make raster image and save it in a file
                ImgWidth = 1500  ' image width, pixels
                bRet = Lcad.BlockRasterize(hBlock, szRasterFile, Lef, Bot, Rig, Top, ImgWidth, 0)
                If bRet = 1 Then
                    MessageBox.Show("Rasterize OK")
                End If
            End If
        End If
    End Sub

    Private Sub ArcToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ArcToolStripMenuItem.Click
        Lcad.WndExeCommand(hLcWnd, LC_CMD_ARC, 0)
    End Sub

    Private Sub LineToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LineToolStripMenuItem.Click
        Lcad.WndExeCommand(hLcWnd, LC_CMD_LINE, 0)
    End Sub

    Private Sub TextToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextToolStripMenuItem.Click
        Lcad.WndExeCommand(hLcWnd, LC_CMD_TEXT, 0)
    End Sub

    Private Sub NewToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click
        Lcad.DrwNew(hLcDrw, "", hLcWnd)
    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Lcad.DrwLoad(hLcDrw, "<Dialog>", hLcWnd)
    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        Lcad.WndExeCommand(hLcWnd, LC_CMD_FILESAVE, 0)
    End Sub

    Private Sub PrintToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintToolStripMenuItem.Click
        Lcad.WndExeCommand(hLcWnd, LC_CMD_PRINT, 0)
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        Lcad.WndExeCommand(hLcWnd, LC_CMD_FILESAVEAS, 0)
    End Sub

    Private Sub RecentToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RecentToolStripMenuItem.Click
        Lcad.DrwLoad(hLcDrw, "<Recent>", hLcWnd)
    End Sub

    Private Sub SaveToMemoryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToMemoryToolStripMenuItem.Click
        Dim MemSize As Integer, bRet As Boolean
        ' get required size for memory buffer
        MemSize = Lcad.DrwSaveMem(hLcDrw, 0, 0)
        If MemSize > 0 Then
            ' alloc memory buffer
            MemBuf = Marshal.AllocHGlobal(MemSize)
            ' write drawing into the buffer
            bRet = Lcad.DrwSaveMem(hLcDrw, MemBuf, MemSize)
        End If
    End Sub

    Private Sub LoadFromMemoryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadFromMemoryToolStripMenuItem.Click
        Dim bRet As Boolean
        If MemBuf <> 0 Then
            bRet = Lcad.DrwLoadMem(hLcDrw, MemBuf, hLcWnd)
            ' free memory buffer
            Marshal.FreeHGlobal(MemBuf)
            MemBuf = 0
        End If
    End Sub

    Private Sub ColorToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ColorToolStripMenuItem.Click
        Dim bRGB As Integer
        Dim idx, R, G, B As Integer
        Dim Msg As String

        Lcad.ColorToVal("255,180,92", bRGB, idx, R, G, B)
        Msg = "255,180,92 : bRGB=" + bRGB.ToString() + " idx=" + idx.ToString() + " R=" + R.ToString() + " G=" + G.ToString() + " B=" + B.ToString()
        Lcad.WndMessage(hLcWnd, Msg, 0)

        Lcad.ColorToVal("red", bRGB, idx, R, G, B)
        Msg = "red : bRGB=" + bRGB.ToString() + " idx=" + idx.ToString() + " R=" + R.ToString() + " G=" + G.ToString() + " B=" + B.ToString()
        Lcad.WndMessage(hLcWnd, Msg, 0)

        Lcad.ColorToVal("cyan", bRGB, idx, R, G, B)
        Msg = "cyan : bRGB=" + bRGB.ToString() + " idx=" + idx.ToString() + " R=" + R.ToString() + " G=" + G.ToString() + " B=" + B.ToString()
        Lcad.WndMessage(hLcWnd, Msg, 0)

        Lcad.ColorToVal("33", bRGB, idx, R, G, B)
        Msg = "33 : bRGB=" + bRGB.ToString() + " idx=" + idx.ToString() + " R=" + R.ToString() + " G=" + G.ToString() + " B=" + B.ToString()
        Lcad.WndMessage(hLcWnd, Msg, 0)

    End Sub
End Class
